package com.aitrainer.api.test

import com.aitrainer.api.ApiApplication
import org.junit.jupiter.api.Test
import org.junit.jupiter.api.TestInstance
import org.junit.runner.RunWith
import org.springframework.beans.factory.annotation.Autowired
import org.springframework.beans.factory.annotation.Value
import org.springframework.boot.test.context.SpringBootTest
import org.springframework.core.io.Resource
import org.springframework.http.HttpStatus
import org.springframework.test.context.ActiveProfiles
import org.springframework.test.context.junit4.SpringRunner
import java.io.FileInputStream
import java.net.URI
import java.security.KeyStore
import java.security.cert.X509Certificate
import java.time.Duration
import javax.net.ssl.KeyManagerFactory
import javax.net.ssl.SSLContext
import javax.net.ssl.TrustManager
import kotlin.test.assertEquals
import kotlin.test.assertTrue


/*@TestInstance(TestInstance.Lifecycle.PER_CLASS)
@RunWith(SpringRunner::class)
@SpringBootTest(classes = [ApiApplication::class], webEnvironment = SpringBootTest.WebEnvironment.DEFINED_PORT)
@ActiveProfiles("ssl")*/
class HttpsApplicationIntegrationTest {
/*    @Value("\${trust.store}")
    @Autowired
    private lateinit var trustStore: Resource

    @Value("\${trust.store.password}")
    @Autowired
    private lateinit var trustStorePassword: String*/
/*

    fun buildClient(): HttpClient? {
        val ks = KeyStore.getInstance("pkcs12")
        val kmf = KeyManagerFactory.getInstance("SunX509")
        //create new ssl context
        val sslContext = SSLContext.getInstance("SSL")
        //load your file to keystore
        ks.load(FileInputStream(trustStore.file.toString()), trustStorePassword.toCharArray())
        kmf.init(ks, trustStorePassword.toCharArray())
        //set global system properties
        System.setProperty("java.protocol.handler.pkgs", "com.sun.net.ssl.internal.www.protocol")
        System.setProperty("javax.net.ssl.keyStoreType", "pkcs12")
        System.setProperty("javax.net.ssl.keyStore", trustStorePassword)
        System.setProperty("javax.net.ssl.keyStorePassword", trustStorePassword)

        //initialize sslContext
        sslContext.init(kmf.keyManagers, getTrustAllCert(), null)

        val client = HttpClient.newBuilder()
            .connectTimeout(Duration.ofSeconds(10))
            .sslContext(sslContext)

            .build()
        //you can send request with your ssl certificate
        return client
    }

    private fun getTrustAllCert(): Array<TrustManager> {

        return arrayOf(object : javax.net.ssl.X509TrustManager {
            override fun getAcceptedIssuers(): Array<X509Certificate>? = null
            override fun checkClientTrusted(certs: Array<X509Certificate>, authType: String) {}
            override fun checkServerTrusted(certs: Array<X509Certificate>, authType: String) {}
        })
    }

    @Test
    fun testSSL() {
        val httpClient: HttpClient? = buildClient()
        if ( httpClient == null) {
            assertTrue(false)
        }
        val request = HttpRequest.newBuilder()
            .uri(URI.create(WELCOME_URL))
            .build()


        val response = httpClient!!.send(request, HttpResponse.BodyHandlers.ofString());
        assertEquals(response.statusCode(), HttpStatus.OK)
        println(response.body())

    }
*/

   /* @Test
    @Throws(Exception::class)
    fun whenGETanHTTPSResource_thenCorrectResponse() {
        val response = restTemplate().getForEntity(
            WELCOME_URL,
            String::class.java, Collections.emptyMap()
        )
        assertEquals("<h1>Welcome to Secured Site</h1>", response.body)
        assertEquals(HttpStatus.OK, response.statusCode)
    }

    @Throws(Exception::class)
    fun restTemplate(): RestTemplate {
        val sslContext: SSLContext =
            SSLContextBuilder().loadTrustMaterial(trustStore.getURL(), trustStorePassword!!.toCharArray())
                .build()
        val socketFactory = SSLConnectionSocketFactory(sslContext)
        val httpClient: HttpClient = HttpClients.custom()
            .setSSLSocketFactory(socketFactory)
            .build()
        val factory = HttpComponentsClientHttpRequestFactory(httpClient)
        return RestTemplate(factory)
    }*/

    companion object {
        private const val WELCOME_URL = "https://localhost:8443/api/welcome"
    }
}