package com.aitrainer.api.repository

import com.aitrainer.api.model.CustomerTrainingPlan
import org.springframework.data.jpa.repository.JpaRepository
import org.springframework.stereotype.Repository

@Repository
interface CustomerTrainingPlanRepository: JpaRepository<CustomerTrainingPlan, Long> {
    fun findAllByCustomerId(customerId: Long): List<CustomerTrainingPlan>
}